function initial_mos = moselcode()

initial_mos = {'model Ship_traffic_control'
' uses "mmxprs";'

'options explterm'
'options noimplicit'

'!setparam("XPRS_FEASTOL",1.0E-04);'

'declarations'
'	Mosel_file:                                                         string;' % Trengs denne?
'   MaxTime:                                                            integer;'
'   MipObjVal:                                                          real;'
'   BestBound:                                                          real;'
'   Gap:                                                                real;'
'	nShips:                                                             integer;'
'	nSidings:                                                           integer;'
'	nTransits:                                                          integer;'
'	nSegments:                                                          integer;'
'   ShipNames:                                                          set of string;'
'	Sidings:                                                            set of integer;'
'	Transits:                                                           set of integer;'
'	Segments:                                                           set of integer;'
'	Ships:                                                              set of integer;'
'	Ships_W:                                                            set of integer;'
'	Ships_E:                                                            set of integer;'
'	ShipSegments:				dynamic array(Ships)					of set of integer;'
'	ShipTransits:				dynamic array(Ships)					of set of integer;'
'	ShipSidings:				dynamic array(Ships)					of set of integer;'
'	SafetyTime:					array(Ships, Ships)						of real;'
'	M:																	real;'
'	Passage_number:				array(Segments)							of integer;'
'	Traffic_group_number:		array(Ships)							of integer;'
'	ETA:						array(Ships)							of real;'
' 	EnteringSegment:			array(Ships)							of integer;'
'	Direction:					array(Ships)							of integer;'
'	EarliestSegmentTime:		array(Ships, Segments)					of real;'
'	!SlowestSegmentTime:			array(Ships, Segments)					of real;'
'   FastestSegmentTime:		array(Ships, Segments)					of real;'
'	ConflictingShips:			dynamic array(Ships, Ships, Segments)	of integer;'
'end-declarations'

'MaxTime := 300;'
'   MipObjVal := 0;'
'   BestBound := 0;'
'   Gap := 0;'


'if(not MaxTime=0)then'
'    setparam("xprs_maxtime", MaxTime);'
'end-if'

'initializations from "matlab.mws:"'
'	Mosel_file;'
'	nShips;'
'	nSidings;'
'	nTransits;'
'	nSegments;'
'   ShipNames;'
'	Sidings;'
'	Transits;'
'	Segments;'
'	Ships;'
'	Ships_W;'
'	Ships_E;'
'	SafetyTime;'
'	M;'
'	Passage_number;'
'	Traffic_group_number;'
'	ETA;'
' 	EnteringSegment;'
'	Direction;'
'	EarliestSegmentTime;'
'	!SlowestSegmentTime;'
'	FastestSegmentTime;'
'	ConflictingShips;'
'end-initializations'

'initializations from Mosel_file'
'	ShipSegments;'
'	ShipTransits;'
'	ShipSidings;'
'end-initializations'

'finalize(Ships);'
'finalize(Sidings);'
'finalize(Transits);'
'finalize(Segments);'
'finalize(Ships_W);'
'finalize(Ships_E);'

'! Declaring variables and restrictions'
'declarations'
'	w:						dynamic array(Ships, Sidings)				of mpvar;'
'	z:						dynamic array(Ships, Ships, Segments)		of mpvar;'
'	t:						dynamic array(Ships, Segments)				of mpvar;'
'	s:						dynamic array(Ships, Segments)				of mpvar;'
'   Waitoutside:            dynamic array(Ships)                        of mpvar;'
'	PassageTimeTransit:		dynamic array(Ships, Transits)				of linctr;'
'	PassageTimeSiding:		dynamic array(Ships, Sidings)				of linctr;'
'	Lower_x_time:			dynamic array(Ships, Segments)				of linctr;'
'	Upper_x_time:			dynamic array(Ships, Segments)				of linctr;'
'	Lower_t_segment:		dynamic array(Ships, Segments)				of linctr;'
'   Outside_waiting:        dynamic array(Ships)                        of linctr;'
'	!a1-a3: Precedence constrains for alligned, eastbound ships'
'	a1:						dynamic array(Ships, Ships, Segments)		of linctr;'
'	a2:						dynamic array(Ships, Ships, Segments)		of linctr;'
'	a3:						dynamic array(Ships, Ships, Segments)		of linctr;'
'	!a4-a7: Precendence constraints for opposed ships'
'	a4:						dynamic array(Ships, Ships, Segments)		of linctr;'
'	a5:						dynamic array(Ships, Ships, Segments)		of linctr;'
'	a6:						dynamic array(Ships, Ships, Segments)		of linctr;'
'	a7:						dynamic array(Ships, Ships, Segments)		of linctr;'
'	!a8-a10: Precendence constraints for alligned, westbound ships'
'	a8:						dynamic array(Ships, Ships, Segments)		of linctr;'
'	a9:						dynamic array(Ships, Ships, Segments)		of linctr;'
'	a10:					dynamic array(Ships, Ships, Segments)		of linctr;'
'	WaitingTime:			linctr;'
'end-declarations'

'! Creating variables'

'! Creating waiting time variables'
'forall(ii in Ships) do'
'	forall(ss in ShipSidings(ii)) do'
'		create(w(ii,ss));'
'	end-do'
'end-do'

'! Creating arrival time variables'
'forall(ii in Ships) do'
'	forall(pp in ShipSegments(ii)) do'
'		create(t(ii,pp));'
'	end-do'
'end-do'

'!Creating travelling time variables'
'forall(ii in Ships) do'
'	forall(pp in ShipSegments(ii)) do'
'		create(s(ii,pp));'
'	end-do'
'end-do'

'forall(ii in Ships) do'
'   create(Waitoutside(ii));'
'end-do'

'! Creating binary variable to ensure precedence, z_ijt = 1 if ship i passes each position of transit t before ship j'
'forall(ii in Ships, jj in Ships) do'
'	forall(pp in ShipSegments(ii)) do'
'		if ConflictingShips(ii,jj,pp) = 1 then'
'			create(z(ii,jj,pp));'
'			z(ii,jj,pp) is_binary;'
'		end-if'
'	end-do'
'end-do'

'! Writing the model'

'! Defining objective function as sum of waiting times'
'WaitingTime := sum(ii in Ships, ss in Sidings) 0.99*w(ii,ss) + sum(ii in Ships, pp in Segments) s(ii,pp) + sum(ii in Ships) (t(ii, EnteringSegment(ii))-ETA(ii));'

'! Making sure that all ships traverses the transits at indicated time'
'forall(ii in Ships_E) do'
'	forall (tt in ShipTransits(ii)) do'
'		PassageTimeTransit(ii, tt) := t(ii,tt) + s(ii,tt) = t(ii,tt+1);'
'	end-do'
'end-do'

'forall(ii in Ships_W) do'
'	forall(tt in ShipTransits(ii)) do'
'		PassageTimeTransit(ii, tt) := t(ii,tt) + s(ii,tt) = t(ii,tt-1);'
'	end-do'
'end-do'

'! Making sure that all ships traverses the sidings at indicated time'
'forall(ii in Ships_E) do'
'	forall(ss in ShipSidings(ii) | ss < nSegments) do'
'		PassageTimeSiding(ii,ss) := t(ii,ss) + s(ii,ss) + w(ii,ss) = t(ii,ss+1);'
'	end-do'
'end-do'

'forall(ii in Ships_W) do'
'	forall(ss in ShipSidings(ii) | ss > 1) do'
'		PassageTimeSiding(ii,ss) := t(ii,ss) + s(ii,ss) + w(ii,ss) = t(ii,ss-1);'
'	end-do'
'end-do'

'! Enforcing ship to travel'
'forall(ii in Ships) do'
'	forall(pp in ShipSegments(ii)) do'
'		Lower_t_segment(ii,pp) := t(ii,pp) >= EarliestSegmentTime(ii,pp);'
'	end-do'
'end-do'

'forall(ii in Ships_E, jj in Ships_E) do'
'	forall(pp in ShipSegments(ii) | exists(z(ii,jj,pp))) do	'
'		!Precedence in segments, enforcing ship i to start before j if z_ije = 1'
'		a1(ii,jj,pp) := t(ii,pp) + SafetyTime(ii,jj) - t(jj,pp) <= (M*(1-z(ii,jj,pp)));'
'		!Precedence in segments, enforcing ship j to start before i if z_ije=0 '
'		a2(ii,jj,pp) := t(jj,pp) + SafetyTime(jj,ii) - t(ii,pp) <= M*z(ii,jj,pp);'
'		if (pp in Transits) then'
'			!Precedence in transit, not allowing for overtaking'
'			a3(ii,jj,pp) := z(ii,jj,pp) >= z(ii,jj,pp+1);'
'		end-if'
'	end-do'
'end-do'

'forall(ii in Ships_E, jj in Ships_W) do'
'	forall(pp in ShipSegments(ii) | exists(z(ii,jj,pp))) do'
'		!Precedence in segments, enforcing ship i to start before j if z_ije = 1	'
'		a4(ii,jj,pp) := t(ii,pp) + s(ii,pp) <= t(jj,pp) + M*(1-z(ii,jj,pp));'
'		!Precedence in segments, enforcing ship j to start before j if z_ije=0 '
'		a5(ii,jj,pp) := t(jj,pp) + s(jj,pp) <= t(ii,pp) + M*z(ii,jj,pp);	'
'	end-do'
'end-do'

'forall(ii in Ships_W, jj in Ships_E) do'
'	forall(pp in ShipSegments(ii) | exists(z(ii,jj,pp))) do	'
'		!Precedence in segments, enforcing ship i to start before j if z_ije = 1'
'		a6(ii,jj,pp) := t(ii,pp) + s(ii,pp) <= t(jj,pp) + M*(1-z(ii,jj,pp));'
'		!Precedence in segments, enforcing ship j to start before j if z_ije=0 '
'		a7(ii,jj,pp) := t(jj,pp) + s(jj,pp) <= t(ii,pp) + M*z(ii,jj,pp);'
'	end-do'
'end-do'

'forall(ii in Ships_W, jj in Ships_W) do'
'	forall(pp in ShipSegments(ii) | exists(z(ii,jj,pp))) do		'
'		!Precedence in segments, enforcing ship i to start before j if z_ije = 1'
'		a8(ii,jj,pp) := t(ii,pp) + SafetyTime(ii,jj) <= t(jj,pp) + M*(1-z(ii,jj,pp));'
'		!Precedence in segments, enforcing ship j to start before i if z_ije=0 '
'		a9(ii,jj,pp) := t(jj,pp) + SafetyTime(jj,ii) <= t(ii,pp) + M*z(ii,jj,pp);'
'		if (pp in Transits) then'
'			!Precedence in transit, not allowing for overtaking'
'			a10(ii,jj,pp) := z(ii,jj,pp-1) <= z(ii,jj,pp) ;'
'		end-if'
'	end-do'
'end-do'

'!Lower and upper bounds on travelling time'
'forall(ii in Ships) do'
'	forall(pp in ShipSegments(ii)) do'
'		Lower_x_time(ii,pp) := s(ii,pp) >= FastestSegmentTime(ii,pp);'
'		!Upper_x_time(ii,pp) := s(ii,pp) <= SlowestSegmentTime(ii,pp);'
'	end-do'
'end-do'
 
'forall(ii in Ships) do'
'   Outside_waiting(ii) := Waitoutside(ii) = t(ii, EnteringSegment(ii))-ETA(ii);'
'end-do'

'! Minimizing waiting time'
'minimize(WaitingTime);'

'MipObjVal := getparam("XPRS_MIPOBJVAL");'
'BestBound := getparam("XPRS_BESTBOUND");'
'Gap := (abs(MipObjVal - BestBound))/MipObjVal;'

'initializations to "matlab.mws:"'
'	evaluation of array(ii in Ships, pp in Segments) t(ii, pp).sol as "Arrival_segment";'
'	evaluation of array(ii in Ships, ss in Sidings) w(ii, ss).sol as "Waiting_time";'
'	evaluation of array(ii in Ships, pp in Segments) s(ii, pp).sol as "Traversing_time";'
'   evaluation of array(ii in Ships, jj in Ships, pp in Segments) z(ii, jj, pp).sol as "Precedence";'
'   evaluation of array(ii in Ships) Waitoutside(ii).sol as "Waiting_outside";'
'	Direction;'
'	Traffic_group_number;'
'	Passage_number;'
'	ETA;'
'   ShipNames;'
'   EnteringSegment;'
'   Gap;'
'end-initializations'


'end-model'};
