function Vesselinfo = Generate_vesselinfo(mean_delay, fraction_ship_delayed, slowsegments_lower, slowsegments_upper, fraction_ship_slow, lower_notice, upper_notice, DelaySeed, SlowSeed, NoticeSeed)

Vesselinfo = readtable('Vesselinfo_big.txt');
Vesselinfo = table2cell(Vesselinfo);

Number_of_ships = size(Vesselinfo, 1);

rng(DelaySeed);
Delays = Create_delays(Number_of_ships, mean_delay, fraction_ship_delayed);

rng(SlowSeed);
Slowships = Create_Slowships(Vesselinfo, fraction_ship_slow);
SlowSegments = Create_SlowSegments(Slowships, Vesselinfo, slowsegments_lower, slowsegments_upper);


Vesselinfo = [Vesselinfo, Delays];

rng(NoticeSeed);
for i = 1:size(Vesselinfo,1)
    Vesselinfo{i, 7} = Vesselinfo{i, 3} + Vesselinfo{i, 6};
    Vesselinfo{i, 8} = Vesselinfo{i, 3} - (lower_notice + randi(upper_notice-lower_notice,1));
end
Slowships = num2cell(Slowships');
Vesselinfo = [Vesselinfo, Slowships, SlowSegments];

end