function [Cum_stats, rollnr] = collect_cum_stat(Cum_stats, Historic_arrival_segment, Historic_waiting_time, Historic_traversing_time, Historic_Waiting_outside, rollnr, Vesselinfo)

%Ave_travel_time = Objective/Scheduled_ships;
%Find rows, or index, for which ships that are not fully traversed
[index_not_fully_traversed,~] = find(Historic_arrival_segment==0);
%index for all ships
index_all_historic_ships = 1:size(Historic_arrival_segment,1);
%Find rows, or index, for all ships that are fully traversed
index_fully_traversed = setdiff(index_all_historic_ships,index_not_fully_traversed);
nFullyTraversed = length(index_fully_traversed);
%initialize vector with travel time per ship
Historic_travel_time = zeros(nFullyTraversed,1);
Statistics_post = [];
if nFullyTraversed == 0
	Total_travel_time = 0;
	Average_travel_time = 0;
	Max_travel_time = 0;
	Average_waiting_cum = 0;
	Max_waiting = 0;
	Max_total_waiting = 0;
else
	for i=1:index_fully_traversed(end)
    	if ismember(i,index_fully_traversed)
        	if Historic_arrival_segment(i,end) - Historic_arrival_segment(i,1) > 0
            	% Direction is eastbound, finding ship's travel time throughout
            	% canal
            	Historic_travel_time(i) = Historic_arrival_segment(i,end) + Historic_traversing_time(i,end) - Vesselinfo{i,7};
        	elseif Historic_arrival_segment(i,1) - Historic_arrival_segment(i,end) > 0
            	% Direction is westbound, finding ship's travel time throughout
            	% canal
            	Historic_travel_time(i) = Historic_arrival_segment(i,1) + Historic_traversing_time(i,1) - Vesselinfo{i,7};
        	end
    	end
	end

%Remove rows which are zero, i.e. only be left with the fully traversed
%ships
Historic_travel_time = Historic_travel_time(Historic_travel_time~=0);

%Total travel time for all ships, aka objective value in composite solution
Total_travel_time = sum(Historic_travel_time);
%Average travel time per fully traversed ship
Average_travel_time = Total_travel_time/nFullyTraversed;
%Max travel time for single ship
Max_travel_time = max(Historic_travel_time);
%All waiting, last column is waiting outside (could be either side of
%canal)
Historic_total_waiting_time = [Historic_waiting_time(index_fully_traversed,:), Historic_Waiting_outside(index_fully_traversed,:)];
%Total waiting per ship
Total_waiting_cum = sum(Historic_total_waiting_time,2);
%Average waiting per ship
Average_waiting_cum = sum(Total_waiting_cum)/nFullyTraversed;
%Maximum single waiting time
Max_waiting = max(max(Historic_total_waiting_time));
%Maximum cumulative waiting
Max_total_waiting = max(Total_waiting_cum);
end

Roll_name = strcat('Roll_', num2str(rollnr));
temp_table = table([Total_travel_time; Average_travel_time; Max_travel_time; Average_waiting_cum; Max_waiting; Max_total_waiting; nFullyTraversed], 'VariableNames', {Roll_name}, 'RowNames', {'Total travelling time' 'Average travel time' 'Max. travel time' 'Average waiting time' 'Max. single waiting time', 'Max. cumulative waiting time', 'Number of traversed ships'});

Cum_stats = horzcat(Cum_stats, temp_table);
rollnr = rollnr + 1;
end