function [WeightingArray, WeightOutside] = createWeightingArray(nShips, nSidings, Direction)
WeightingArray = zeros(nShips, nSidings);

for i = 1:nShips
    if Direction(i) == 1 %Eastbound
        temp = linspace(1.1,0.9,nSidings+1);
        WeightingArray(i,:) = temp(2:end);
        WeightOutside(i) = temp(1);
    else %Westbound
        temp = linspace(0.9,1.1,nSidings+1);
        WeightingArray(i,:) = temp(1:end-1);
        WeightOutside(i) = temp(end);
    end
end

WeightingArray = kron(WeightingArray, [1,1]);
WeightingArray(:,end) = [];
end


