function [Historic_arrival_segment, Historic_waiting_time, Historic_traversing_time, last_time] = create_historic_path(time, last_time, Arrival_segment, Traversing_time, Waiting_time, ShipNames, Historic_arrival_segment, Historic_waiting_time, Historic_traversing_time)

% First we create a vector containing the number of all the ships in
% Arrival_segment. This is done by extracting the number from the ships in
% ShipNames
nSegments = size(Arrival_segment,2);
nShipsInArrivalSegment = length(ShipNames);

ShipNumbers = zeros(nShipsInArrivalSegment,1);

for i = 1:nShipsInArrivalSegment
    ShipNumbers(i) = str2num(ShipNames{i,:}(8:end));
end

% Checking to see what the latest ship in ShipNumbers are. Historic needs
% to have at least this length

LatestShip = max(ShipNumbers);

% Extending Historic by the difference by its current size and LatestShip
Extension = LatestShip - size(Historic_arrival_segment,1);

if Extension > 0
    Historic_arrival_segment = vertcat(Historic_arrival_segment, zeros(Extension,nSegments));
    Historic_traversing_time = vertcat(Historic_traversing_time, zeros(Extension,nSegments));
    Historic_waiting_time = vertcat(Historic_waiting_time, zeros(Extension,(nSegments+1)/2));
end

% The extending is done, and Historic will now have one row for every ship
% that has been planned for (including ships that are late and have not yet
% arrived)

% Finding the times that are going into historic
SegmentsPassed = (Arrival_segment < time & Arrival_segment-last_time >= -eps(10^5));

Waiting_time_kron = kron(Waiting_time, [1,0]);
Waiting_time_kron = Waiting_time_kron(:,1:end-1);

% Updating Historic with these times
for i = 1:size( Arrival_segment,1)
    IndiciesForUpdating = find(SegmentsPassed(i,:)>0);
    Historic_arrival_segment(ShipNumbers(i), IndiciesForUpdating) = Arrival_segment(i, IndiciesForUpdating);
    Historic_traversing_time(ShipNumbers(i), IndiciesForUpdating) = Traversing_time(i, IndiciesForUpdating);
    % Historic_waiting_time(ShipNumbers(i), unique(floor((IndiciesForUpdating+1)/2))) = Waiting_time(i, unique(floor((IndiciesForUpdating+1)/2)));
    for j = 1:nSegments
        if (Waiting_time_kron(i,j) > 0) && (Arrival_segment(i,j) + Traversing_time(i,j) + Waiting_time_kron(i,j) < time)
            Historic_waiting_time(ShipNumbers(i), (j+1)/2) = Waiting_time_kron(i,j);
        end
    end
end

last_time = time;

end
