clearvars;

RT = 5;

lower_NT = [120, 240, 360];
upper_NT = [240, 360, 480];

% Huskeliste:
% Sjekk ka RT mappe du er i og at RT samsvarer
% Legg til xpress i pathen
% Sjekk visualize og T_end og at intervalla er rett
% Dersom du ikkje kjre standardcase, oppdater navngiving av excelfilene!!
% Evt hopp over spesifikke case, husk  bruk &&
% Kjr med pause when errors

Simulator_parameters = [0 0 0 0 0;
                        0.15 30 0 0 0; 
                        0.30 60 0 0 0; 
                        0 0 0.2 1 2;
                        0 0 0.5 3 5;
                        0.15 30 0.2 1 2; 
                        0.3 60 0.5 3 5
                        ];
                        

Delay_scaling = [2/3 2/3;
                 1 1;
                 4/3 4/3];
   
Visualize = 0;

T_end = 10080;

Historic_arrival_segment_FT = cell(1, length(lower_NT)*size(Simulator_parameters,1));
Historic_traversing_segment_FT = cell(1, length(lower_NT)*size(Simulator_parameters,1));
Historic_waiting_segment_FT = cell(1, length(lower_NT)*size(Simulator_parameters,1));
Historic_vesselinfo_FT = cell(1, length(lower_NT)*size(Simulator_parameters,1));

%Timestamp 24.05.2018 17:59
for noticetime = 1:length(lower_NT)
    for cases = 1:size(Simulator_parameters,1)
        NoticeSeed = 1;
        DelaySeed = 2;
        SlowSeed = 3;
        A_time_lower = lower_NT(noticetime);
        A_time_upper = upper_NT(noticetime);
        fraction_ship_delayed = Simulator_parameters(cases, 1)*Delay_scaling(noticetime, 1);
        mean_delay = Simulator_parameters(cases, 2)*Delay_scaling(noticetime, 2);
        fraction_ship_slow = Simulator_parameters(cases, 3);
        slowsegments_lower = Simulator_parameters(cases, 4);
        slowsegments_upper = Simulator_parameters(cases, 5);
        [Statistics_post, Statistics, Cum_stats, Historic_arrival_segment, Historic_waiting_time, Historic_traversing_time, Vesselinfo] = Simulering(RT, NoticeSeed, DelaySeed, SlowSeed, A_time_lower, A_time_upper, fraction_ship_delayed, mean_delay, fraction_ship_slow, slowsegments_lower, slowsegments_upper, Visualize, T_end);
        excelname = strcat('RT', num2str(RT), '_AT', num2str(noticetime*2), num2str(2*noticetime+2), '_Case', num2str(cases), '.xlsx');
        writetable(Statistics, excelname, 'Sheet', 1, 'Range', 'A2', 'WriteRowNames', true);
        writetable(Cum_stats, excelname, 'Sheet', 1, 'Range', 'B10', 'WriteRowNames', true);
        writetable(Statistics_post, excelname, 'Sheet', 1, 'Range', 'A19', 'WriteRowNames', true);
        status1 = xlswrite(excelname, Historic_arrival_segment, 2);
        status2 = xlswrite(excelname, Historic_traversing_time, 3);
        status3 = xlswrite(excelname, Historic_waiting_time, 4);
        status4 = xlswrite(excelname, Vesselinfo(1:size(Historic_arrival_segment,1),1:9), 5);
        if status1 + status2 + status3 + status4 ~= 4
            keyboard;
        end
    end
end